﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KMAP
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        #region OnStart stuff.
        // When the form loads, input the math in the various richtextboxes.
        private void Form1_Load(object sender, EventArgs e)
        {
            TWRTab_TWRMath_RichTextBox.SelectedRtf = Properties.Resources.TWRMath;
            IspTab_IspMath_RichTextBox.SelectedRtf = Properties.Resources.IspMath;
            DVTab_DeltaVMath_RichTextBox.SelectedRtf = Properties.Resources.DeltaVMath;
            OPTab_OPMath_RichTextBox.SelectedRtf = Properties.Resources.OPMath;
            OPTab_SemMajAxMath_RichTextBox.SelectedRtf = Properties.Resources.SemMajAxMath;
        }

        // TextBox input validation (Don't allow letters to be inputted into the text boxes).
        // The only thing that can bypass it is the user using ctrl+v to paste something. Fix this later with a "TextChanged" event.
        private void TextBox_NumericOnly_KeyPress(object sender, KeyPressEventArgs e)
        {
            //if input is not a control char, digit, or '.', do nothing.
            if (!char.IsControl(e.KeyChar) && !char.IsDigit(e.KeyChar) && (e.KeyChar != '.'))
            {
                e.Handled = true;
            }

            //only allow one decimal point
            //user inputs '.' and there's already one.
            if ((e.KeyChar == '.') && ((sender as TextBox).Text.IndexOf('.') > -1))
            {
                e.Handled = true;
            }
        }
        #endregion


        #region Functions
        // Zero or null input error warning.
        async private void InputErrorWarning()
        {
            await Task.Delay(1);
            MessageBox.Show("Input cannot be empty or zero.", "INPUT ERROR");
        }

        // Body Radius ComboBox Text Replacer Function.
        async private void BodyRadiusComboBoxTextReplacer()
        {
            await Task.Delay(1);

            string PlanetName = OPTab_InputBodyRadius_ComboBox.Text;
            switch (PlanetName)
            {
                case "Kerbol":
                    OPTab_InputBodyRadius_ComboBox.Text = "261600000";
                    break;

                case "Moho":
                    OPTab_InputBodyRadius_ComboBox.Text = "250000";
                    break;

                case "Eve":
                    OPTab_InputBodyRadius_ComboBox.Text = "700000";
                    break;

                case "Gilly":
                    OPTab_InputBodyRadius_ComboBox.Text = "13000";
                    break;

                case "Kerbin":
                    OPTab_InputBodyRadius_ComboBox.Text = "600000";
                    break;

                case "Mun":
                    OPTab_InputBodyRadius_ComboBox.Text = "200000";
                    break;

                case "Minmus":
                    OPTab_InputBodyRadius_ComboBox.Text = "60000";
                    break;

                case "Duna":
                    OPTab_InputBodyRadius_ComboBox.Text = "320000";
                    break;

                case "Ike":
                    OPTab_InputBodyRadius_ComboBox.Text = "130000";
                    break;

                case "Dres":
                    OPTab_InputBodyRadius_ComboBox.Text = "138000";
                    break;

                case "Jool":
                    OPTab_InputBodyRadius_ComboBox.Text = "6000000";
                    break;

                case "Laythe":
                    OPTab_InputBodyRadius_ComboBox.Text = "500000";
                    break;

                case "Vall":
                    OPTab_InputBodyRadius_ComboBox.Text = "300000";
                    break;

                case "Tylo":
                    OPTab_InputBodyRadius_ComboBox.Text = "600000";
                    break;

                case "Bop":
                    OPTab_InputBodyRadius_ComboBox.Text = "65000";
                    break;

                case "Pol":
                    OPTab_InputBodyRadius_ComboBox.Text = "44000";
                    break;

                case "Eeloo":
                    OPTab_InputBodyRadius_ComboBox.Text = "210000";
                    break;
            }
            #region Planet Radii
            // Kerbol - 261,600,000 m
            // Moho - 250,000 m
            //Eve - 700,000 m
            //Gilly - 13,000 m
            //Kerbin - 600,000 m
            //Mun - 200,000 m
            //Minmus - 60,000 m
            //Duna - 320,000 m
            //Ike - 130,000 m
            //Dres - 138,000 m
            //Jool - 6,000,000 m
            //Laythe - 500,000 m
            //Vall - 300,000 m
            //Tylo - 600,000 m
            //Bop - 65,000 m
            //Pol - 44,000 m
            //Eeloo - 210,000 m
            #endregion
        }

        // Body Mass ComboBox Text Replacer Function.
        async private void BodyMassComboBoxTextReplacer()
        {
            await Task.Delay(1);

            #region Switch-Space
            string PlanetName = OPTab_InputBodyMass_ComboBox.Text;
            switch (PlanetName)
            {
                case "Kerbol":
                    OPTab_InputBodyMass_ComboBox.Text = "1.7565670e+28";
                    break;

                case "Moho":
                    OPTab_InputBodyMass_ComboBox.Text = "2.5263617e+21";
                    break;

                case "Eve":
                    OPTab_InputBodyMass_ComboBox.Text = "1.2244127e+23";
                    break;

                case "Gilly":
                    OPTab_InputBodyMass_ComboBox.Text = "1.2420512e+17";
                    break;

                case "Kerbin":
                    OPTab_InputBodyMass_ComboBox.Text = "5.2915793e+22";
                    break;

                case "Mun":
                    OPTab_InputBodyMass_ComboBox.Text = "9.7600236e+20";
                    break;

                case "Minmus":
                    OPTab_InputBodyMass_ComboBox.Text = "2.6457897e+19";
                    break;

                case "Duna":
                    OPTab_InputBodyMass_ComboBox.Text = "4.5154812e+21";
                    break;

                case "Ike":
                    OPTab_InputBodyMass_ComboBox.Text = "2.7821949e+20";
                    break;

                case "Dres":
                    OPTab_InputBodyMass_ComboBox.Text = "3.2191322e+20";
                    break;

                case "Jool":
                    OPTab_InputBodyMass_ComboBox.Text = "4.2332635e+24";
                    break;

                case "Laythe":
                    OPTab_InputBodyMass_ComboBox.Text = "2.9397663e+22";
                    break;

                case "Vall":
                    OPTab_InputBodyMass_ComboBox.Text = "3.1088028e+21";
                    break;

                case "Tylo":
                    OPTab_InputBodyMass_ComboBox.Text = "4.2332635e+22";
                    break;

                case "Bop":
                    OPTab_InputBodyMass_ComboBox.Text = "3.7261536e+19";
                    break;

                case "Pol":
                    OPTab_InputBodyMass_ComboBox.Text = "1.0813636e+19";
                    break;

                case "Eeloo":
                    OPTab_InputBodyMass_ComboBox.Text = "1.1149358e+21";
                    break;
            }
            #endregion
            #region Planet Mass
            // Kerbol - 1.7565670e+28 kg
            // Moho - 2.5263617e+21 kg
            // Eve - 1.2244127e+23 kg
            // Gilly - 1.2420512e+17 kg
            // Kerbin - 5.2915793e+22 kg
            // Mun - 9.7600236e+20 kg
            // Minmus - 2.6457897e+19 kg
            // Duna - 4.5154812e+21 kg
            // Ike - 2.7821949e+20 kg
            // Dres - 3.2191322e+20 kg
            // Jool - 4.2332635e+24 kg
            // Laythe - 2.9397663e+22 kg
            // Vall - 3.1088028e+21 kg
            // Tylo - 4.2332635e+22 kg
            // Bop - 3.7261536e+19 kg
            // Pol - 1.0813636e+19 kg
            // Eeloo - 1.1149358e+21 kg
            #endregion
        }
        #endregion


        #region Thrust to Weight Ratio Section
        // When I change the inputs for Thrust or Mass, then clear all other text boxes.
        private void TWRAccelerationInputsTextBox_TextChanged(object sender, EventArgs e)
        {
            TWRTab_OutputAccel_TextBox.Text = "0";
            TWRTab_InputAccel_TextBox.Text = "0";
            TWRTab_OutputTWR_TextBox.Text = "0";
        }

        // When I change the input for acceleration or gravity, then clear the TWR output text box.
        private void TWRInputsTextBox_TextChanged(object sender, EventArgs e)
        {
            TWRTab_OutputTWR_TextBox.Text = "0";
        }

        // Clicking the TWR-acceleration Calculate button.
        private void button1_Click_1(object sender, EventArgs e)
        {
            // Check if any of these values are null or zero.
            if (String.IsNullOrEmpty(TWRTab_InputThrust_TextBox.Text) || double.Parse(TWRTab_InputThrust_TextBox.Text) == 0 || String.IsNullOrEmpty(TWRTab_InputMass_TextBox.Text) || double.Parse(TWRTab_InputMass_TextBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            //Set the thrust and mass inputs to numbers I can use, and then calculate that out as the output for the TWR.
            double thrustinput = double.Parse(TWRTab_InputThrust_TextBox.Text);
            double massinput = double.Parse(TWRTab_InputMass_TextBox.Text);
            TWRTab_OutputAccel_TextBox.Text = (thrustinput / massinput).ToString();

            //Let's set the input acceleration textbox as well.
            TWRTab_InputAccel_TextBox.Text = TWRTab_OutputAccel_TextBox.Text;
        }

        // Clicking the TWR-TWR calculate button.
        private void TWRCalculate_Click(object sender, EventArgs e)
        {
            // Check if any of these values are null or zero.
            if (String.IsNullOrEmpty(TWRTab_InputAccel_TextBox.Text) || double.Parse(TWRTab_InputAccel_TextBox.Text) == 0 || String.IsNullOrEmpty(TWRTab_InputGrav_TextBox.Text) || double.Parse(TWRTab_InputGrav_TextBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            double gravityinput = double.Parse(TWRTab_InputGrav_TextBox.Text);
            double accelerationinput = double.Parse(TWRTab_OutputAccel_TextBox.Text);
            TWRTab_OutputTWR_TextBox.Text = (accelerationinput / gravityinput).ToString();
        }
        #endregion


        #region ISP Section
        // Clicking the "Add" button for the listView in the Isp tab.
        private void Isp_addButton1_Click(object sender, EventArgs e)
        {
            // Check if any of these values are null or zero.
            if (String.IsNullOrEmpty(IspTab_InputIsp_TextBox.Text) || double.Parse(IspTab_InputIsp_TextBox.Text) == 0 || String.IsNullOrEmpty(IspTab_InputThrust_TextBox.Text) || double.Parse(IspTab_InputThrust_TextBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            // Grab the variables from the input method.
            double thrustinput = double.Parse(IspTab_InputThrust_TextBox.Text);
            double ispinput = double.Parse(IspTab_InputIsp_TextBox.Text);

            // Check if any of these values are 0.
            if (thrustinput == 0 || ispinput == 0)
            {
                MessageBox.Show("Input cannot be zero.", "INPUT ERROR");
                return;
            }

            // We create a new ListViewItem in the memory. essentially this is a new row in the listView
            ListViewItem itemToAdd = new ListViewItem();
            // This '.Text' is what we see in the first column of the listview.
            itemToAdd.Text = (IspTab_IspCalculator_listView.Items.Count + 1).ToString();

            // This subitem is what we see in the second column. as we continue adding subitems, each column gets populated.
            itemToAdd.SubItems.Add(thrustinput.ToString());
            itemToAdd.SubItems.Add(ispinput.ToString());

            // Finally, add the item we created to the listview.
            IspTab_IspCalculator_listView.Items.Add(itemToAdd);

            // And reset the input box entries to 0.
            IspTab_InputThrust_TextBox.Text = "0";
            IspTab_InputIsp_TextBox.Text = "0";

            // And also reset the total Isp to 0.
            IspTab_OutputIsp_TextBox.Text = "0";
        }

        // Clicking the "Remove" button for the listView in the Isp tab.
        private void Isp_addButton2_Click(object sender, EventArgs e)
        {
            // We get the number of items in the ListView.
            int count = IspTab_IspCalculator_listView.Items.Count;

            // If there isn't at least one item, then do nothing.
            if (count < 1)
            {
                return;
            }   // At this point we know the ListView has at least one item.

            // If we have nothing selected, then just delete the last one.
            if (IspTab_IspCalculator_listView.SelectedItems.Count < 1)
            {
                IspTab_IspCalculator_listView.Items.RemoveAt(count - 1);
            }
            else // We didn't have nothing selected. So we have something selected.
            {
                // Temporarily saving the selected items index
                int selectedItem = IspTab_IspCalculator_listView.FocusedItem.Index;

                // Remove that item
                IspTab_IspCalculator_listView.Items.RemoveAt(selectedItem);

                // Updating the indices of all the items below the one we deleted.
                for (int i = selectedItem; i < count - 1; i++)
                {
                    IspTab_IspCalculator_listView.Items[i].Text = (i + 1).ToString();
                }
            }

            // And also reset the total Isp to 0.
            IspTab_OutputIsp_TextBox.Text = "0";
        }

        // Calculating the Isp
        // you know what += does? i += 1 is the same as i = i + 1
        private void IspTab_IspCalculator_CalculateButton_Click(object sender, EventArgs e)
        {
            // Default the variables to 0.
            double totalThrust = 0;
            double sumOfThrustDividedByIsp = 0;

            foreach (ListViewItem engine in IspTab_IspCalculator_listView.Items)
            {
                double thrust = double.Parse(engine.SubItems[1].Text);
                double isp = double.Parse(engine.SubItems[2].Text);

                totalThrust += thrust;
                sumOfThrustDividedByIsp += (thrust / isp);
            }
            IspTab_OutputIsp_TextBox.Text = (totalThrust / sumOfThrustDividedByIsp).ToString();
        }
        #endregion
        

        #region Delta V Section
        // When I change the inputs for Delta V, clear the output.
        private void DVTab_DVInputs_TextBox_TextChanged(object sender, EventArgs e)
        {
            DVTab_OutputDV_TextBox.Text = "0";
        }

        // Clicking the Delta V calculate button.
        private void DeltaVCalculate_Button_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(DVTab_InputIsp_TextBox.Text) || double.Parse(DVTab_InputIsp_TextBox.Text) == 0
                ||
                String.IsNullOrEmpty(DVTab_InputGravity_TextBox.Text) || double.Parse(DVTab_InputGravity_TextBox.Text) == 0
                ||
                String.IsNullOrEmpty(DVTab_InputTotalMass_TextBox.Text) || double.Parse(DVTab_InputTotalMass_TextBox.Text) == 0
                ||
                String.IsNullOrEmpty(DVTab_InputDryMass_TextBox.Text) || double.Parse(DVTab_InputDryMass_TextBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            double ispinput = double.Parse(DVTab_InputIsp_TextBox.Text);
            double gravityinput = double.Parse(DVTab_InputGravity_TextBox.Text);
            double totalmassinput = double.Parse(DVTab_InputTotalMass_TextBox.Text);
            double drymassinput = double.Parse(DVTab_InputDryMass_TextBox.Text);

            DVTab_OutputDV_TextBox.Text = (ispinput * gravityinput * Math.Log(totalmassinput / drymassinput)).ToString();
        }

        // Clicking the Total Delta V add button.
        private void DVTab_TotalDVCalculator_addButton_Click(object sender, EventArgs e)
        {
            // Check if any of these values are null or zero.
            if (String.IsNullOrEmpty(DVTab_InputDV_TextBox.Text) || double.Parse(DVTab_InputDV_TextBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            // Grab the variables from the input method.
            double dvinput = double.Parse(DVTab_InputDV_TextBox.Text);

            // We create a new ListViewItem in the memory. essentially this is a new row in the listView
            ListViewItem itemToAdd = new ListViewItem();
            // This '.Text' is what we see in the first column of the listview.
            itemToAdd.Text = (DVTab_TotalDVCalc_listView.Items.Count + 1).ToString();

            // This subitem is what we see in the second column. as we continue adding subitems, each column gets populated.
            itemToAdd.SubItems.Add(dvinput.ToString());

            // Finally, add the item we created to the listview.
            DVTab_TotalDVCalc_listView.Items.Add(itemToAdd);

            //And reset the input box entries to 0.
            DVTab_InputDV_TextBox.Text = "0";

            //And also reset the total DV to 0.
            DVTab_OutputTotalDV_TextBox.Text = "0";
        }

        // Clicking the Total Delta V calculator remove button.
        private void DVTab_TotalDVCalculator_removeButton_Click(object sender, EventArgs e)
        {
            // We get the number of items in the ListView.
            int count = DVTab_TotalDVCalc_listView.Items.Count;

            // If there isn't at least one item, then do nothing.
            if (count < 1)
            {
                return;
            }   // At this point we know the ListView has at least one item.

            // If we have nothing selected, then just delete the last one.
            if (DVTab_TotalDVCalc_listView.SelectedItems.Count < 1)
            {
                DVTab_TotalDVCalc_listView.Items.RemoveAt(count - 1);
            }
            else // We didn't have nothing selected. So we have something selected.
            {
                // Temporarily saving the selected items index
                int selectedItem = DVTab_TotalDVCalc_listView.FocusedItem.Index;

                // Remove that item
                DVTab_TotalDVCalc_listView.Items.RemoveAt(selectedItem);

                // Updating the indices of all the items below the one we deleted.
                for (int i = selectedItem; i < count - 1; i++)
                {
                    DVTab_TotalDVCalc_listView.Items[i].Text = (i + 1).ToString();
                }
            }

            //And also reset the total Isp to 0.
            DVTab_OutputTotalDV_TextBox.Text = "0";
        }

        // Clicking the Total Delta V calculate button.
        private void DVTab_TotalDVCalculator_CalculateButton_Click(object sender, EventArgs e)
        {
            // Default the variables to 0.
            double totalDV = 0;

            foreach (ListViewItem stage in DVTab_TotalDVCalc_listView.Items)
            {
                double DV = double.Parse(stage.SubItems[1].Text);

                totalDV += DV;
            }
            DVTab_OutputTotalDV_TextBox.Text = (totalDV).ToString();
        }
        #endregion


        #region Orbital Period Section
        // When the inputs for the Semi-Major Axis are changed, clear the Semi-Major Axis output textbox,
        // the Semi-Major Axis input textbox, and the Orbital Period output textbox.
        private void OPTab_SemMajAxInputs_Changed(object sender, EventArgs e)
        {
            OPTab_OutputSemMajAx_TextBox.Text = "0";
            OPTab_OutputOP_TextBox.Text = "0";
        }

        // When the inputs for the Orbital Period are changed, clear the Orbital Period output textbox.
        private void OPTab_OPInputs_TextChanged(object sender, EventArgs e)
        {
            OPTab_OutputOP_TextBox.Text = "0";
        }

        // Body Radius ComboBox text replaced when you click an option in the dropdown.
        private void OPTab_SemMajAxCalculator_BodyRadius_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            BodyRadiusComboBoxTextReplacer();
        }

        // Body Mass ComboBox text replaced when you click an option in the dropdown.
        private void OPTab_OPCalculator_BodyMass_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            BodyMassComboBoxTextReplacer();
        }

        // Calculating the Semi-Major Axis.
        private void OPTab_SemMajAxCalculator_CalculateButton_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(OPTab_InputApo_TextBox.Text) || double.Parse(OPTab_InputApo_TextBox.Text) == 0
                ||
                String.IsNullOrEmpty(OPTab_InputPeri_TextBox.Text) || double.Parse(OPTab_InputPeri_TextBox.Text) == 0
                ||
                String.IsNullOrEmpty(OPTab_InputBodyRadius_ComboBox.Text) || double.Parse(OPTab_InputBodyRadius_ComboBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            double apoapsisinput = double.Parse(OPTab_InputApo_TextBox.Text);
            double periapsisinput = double.Parse(OPTab_InputPeri_TextBox.Text);
            double bodyradiusinput = double.Parse(OPTab_InputBodyRadius_ComboBox.Text);

            OPTab_OutputSemMajAx_TextBox.Text = ((apoapsisinput + periapsisinput + (2*bodyradiusinput))/2).ToString();
            OPTab_InputSemMajAx_TextBox.Text = OPTab_OutputSemMajAx_TextBox.Text;
        }

        // Calculating the Oribtal Period.
        private void OPTab_OPCalc_CalculateButton_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(OPTab_InputSemMajAx_TextBox.Text) || double.Parse(OPTab_InputSemMajAx_TextBox.Text) == 0 || String.IsNullOrEmpty(OPTab_InputBodyMass_ComboBox.Text) || double.Parse(OPTab_InputBodyMass_ComboBox.Text) == 0)
            {
                InputErrorWarning();
                return;
            }

            double twopiinput = Math.PI * 2;
            double semmajaxinput = double.Parse(OPTab_InputSemMajAx_TextBox.Text);
            double gravconstinput = double.Parse(OPTab_InputGravConst_TextBox.Text);
            double bodymassinput = double.Parse(OPTab_InputBodyMass_ComboBox.Text);

            OPTab_OutputOP_TextBox.Text = ( twopiinput * Math.Sqrt(Math.Pow(semmajaxinput, 3) / (gravconstinput * bodymassinput)) ).ToString();
        }
        #endregion
    }
}
